#-----------------------------------------------------------
#to define application variable.
%define muser %{name}
%define sqldbname %{name}
%define sqldbport 5432
%define sqldbtype POSTGRESQL
%ifarch x86_64
%define ap_arch x86_64
%endif
#-----------------------------------------------------------
#release DATE
%define	rpmdate		"2012-11-19 16:42:28"
#version componentes
%define	rversion	2
%define	rlevel		5
%define	rrelease	148
%define	rupdate		9
%define	rextension	9
%define	rvers		%{rversion}.%{rlevel}
#-----------------------------------------------------------
#database specific requires
%{!?with_postgresql:%define with_postgresql 1}
%{!?with_mysql:%define with_mysql 1}
%define with_repo 1
%{!?orig:%define with_repo 0}
%{!?dist:%define with_repo 0}
#---------------------------------------------------------------
Name: clement
Summary: clement is an application to filter and manage E-mail traffic
Group: System Environment/Daemons
Version: %{rvers}.%{rrelease}
Release: %{rextension}%{?dist}
License: GPLv2
Source: ftp://ftp.safe.ca/pub/srctgz/%{name}-%{version}.tgz
URL: http://www.clement.safe.ca/index.html
Vendor: SAFE Inc.
Requires: /usr/sbin/crond
Requires: logrotate
Requires: httpd, mod_ssl, squirrelmail
Requires: /bin/sh, /bin/cut, /usr/bin/cpp, /usr/bin/du
Requires: openssl, rrdtool, dovecot >= 1.2, rsync, php >= 5.2, php-imap
Requires: clamav-server, /usr/bin/spamd
Requires: which, bc
Requires(pre): /usr/sbin/useradd,/usr/sbin/userdel
Requires(post): /usr/bin/dig
BuildRequires: /usr/bin/byacc, /usr/bin/cpp
BuildRequires: zlib-devel,bzip2-devel,gmp-devel,pam-devel,openssl-devel
%if %with_repo
Requires(pre): %{name}-repo = %{version}-%{release}
%endif

#---------------------------------------------------------------
buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)


%description
Clement is an email firewall. Its purpose is to filter all email,
rejecting viruses and unwelcome messages at the SMTP protocol level
(and avoids bouncing to forged originators).
It also provide audit logs, allowing effective mean to search about email exchange 
within time and transaction context.

Clement extracts "email sending contexts" and can use a remote mentor
process to further analyze message context while still connected to the
remote sender process.

%files
%defattr(-,%{name},mail,-) 
%doc %{name}-%{version}*.build_date README
%{_usr}/lib/%{name}-%{rvers}/
%{_var}/lib/%{name}-%{rvers}/
%{_var}/log/%{name}/
%{_var}/www/%{name}-%{rvers}/
%{_sbindir}/%{name}
%{_bindir}/pibsmtp
%{_bindir}/clmsndr
%{_bindir}/clmtrst
#system level.
%attr(-,root,root) %config(noreplace) %{_sysconfdir}/cron.d/%{name}
%config(noreplace) %{_sysconfdir}/pki/%{name}-%{rvers}/trusted.pem
%config(noreplace) %{_sysconfdir}/pki/%{name}-%{rvers}/startcom.ca.pem
%config(noreplace) %{_sysconfdir}/pki/%{name}-%{rvers}/StartComClass2PrimaryIntermediateServerCA
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
#rotating dovecot logs
%{_sysconfdir}/logrotate.d/clem-dovecot
#init level
%attr(0755,root,root) %{_initrddir}/%{name}
#working level
%config(noreplace) %{_sysconfdir}/%{name}-%{rvers}/

%{_var}/spool/%{name}-%{rvers}/
%attr(0770,%{name},mail) %{_var}/crash/%{name}-%{rvers}/
%{_var}/lock/%{name}-%{rvers}/

#-----------------------------------------------------------
#This is the RPM install/upgrade/remove directive
#-----------------------------------------------------------
#before install or upgrade
%pre
if [ "$1" = 1 ]; then
  /usr/sbin/useradd -g mail -M -d /var/spool/%{name}-%{rvers} \
        -c "${name} daemon" \
        -s /bin/bash %{name} 2>/dev/null || :
  fi
if [ "$1" = 2 ]; then
  if [ -f %{_usr}/lib/%{name}-%{rvers}/shell/version.sh ] ; then
    cp -f %{_usr}/lib/%{name}-%{rvers}/shell/version.sh	\
          %{_usr}/lib/%{name}-%{rvers}/shell/prev-version.sh
    fi
  fi


#after install or upgrade
%post
#fist install
if [ "$1" = 1 ]; then
  /sbin/chkconfig --add %{name} 2>/dev/null || :
  /sbin/chkconfig %{name} on 2>/dev/null || :
  if [ -n "%{?ap_arch}" ] ; then
    (
    echo "#------------------------------------------"
    echo "#Architecture type is set by rpm install procedure"
    echo "AP_ARCH=%{?ap_arch}"
    echo "#------------------------------------------"
    ) >> %{_sysconfdir}/sysconfig/%{name}
    fi
  fi
#before re-install
if [ "$1" = 2 ]; then
  (
  if [ -f /var/lock/subsys/%{name} ] ; then
    export GOCLEM="GO"
    %{_initrddir}/%{name} stop 2>/dev/null || :
    fi
  if [ -f /var/lock/subsys/dovecot ] ; then
    export GODOV="GO"
    %{_initrddir}/dovecot stop 2>/dev/null || :
    fi
  %{_usr}/lib/%{name}-%{rvers}/utilities/update_files_version.sh
  /bin/su - %{name} %{_usr}/lib/%{name}-%{rvers}/utilities/update_db_version.sh
  sleep 5		#waiting clement full shutdown
  if [ -n "$GODOV" ] ; then
    %{_initrddir}/dovecot start 2>/dev/null || :
    fi
  if [ -n "$GOCLEM" ] ; then
    %{_initrddir}/%{name} start 2>/dev/null || :
    fi
  )
  fi

#before upgrade or remove
%postun

#after upgrade or remove
%preun
if [ "$1" = 0 ]; then
  if [ -f /var/lock/subsys/%{name} ] ; then
    %{_initrddir}/%{name} stop 2>/dev/null || :
    fi
  /sbin/chkconfig --del %{name} 2>/dev/null || :
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  /bin/echo "remaining file in this directory are data-base and logs"
  /bin/echo "created while %{name} was in production."
  /bin/echo "these files _may_ be removed too, but that they could"
  /bin/echo "contain valuable data and admin should be careful"
  /bin/echo "when removing them."
  ) > %{_var}/spool/%{name}-%{rvers}/README-%{name}-removed
  cp %{_var}/spool/%{name}-%{rvers}/README-%{name}-removed \
     %{_var}/lib/%{name}-%{rvers}/README-%{name}-removed
  /usr/sbin/userdel -r %{name} > /dev/null 2>&1 || true
  fi

#-----------------------------------------------------------
#package definition
#-----------------------------------------------------------
%if %with_repo
%package repo
Summary: Repository Clement package from SAFE Inc.
Group: System Environment/Daemons
Version: %{rvers}.%{rrelease}
Release: %{rextension}%{?dist}
License: GPLv2
Requires: yum

%description repo
The clement application SAFE repository data

%files repo
%config(noreplace) %{_sysconfdir}/yum.repos.d/%{name}.repo

%endif

%if %with_postgresql
%package pgsql
Summary: Clement package working with postgresql data-base
Group: System Environment/Daemons
Version: %{rvers}.%{rrelease}
Release: %{rextension}%{?dist}
License: GPLv2
Requires(pre): %{name} = %{version}-%{release}
Requires: postgresql-server
Requires: dovecot-pgsql,php-pgsql
Requires: /bin/sed
Requires: postgresql
BuildRequires: postgresql-devel

%description pgsql
The clement application set to work with a PostgreSQL data-base

%files pgsql

%post pgsql
if [ "$1" = 1 ]; then
  (
  echo "#------------------------------------------"
  echo "#DATA BASE TYPE as set by %{name}-pgsql RPM"
  echo "DB_TYPE=POSTGRESQL"
  echo "#------------------------------------------"
  ) >> %{_sysconfdir}/sysconfig/%{name}
  (
  echo "#------------------------------------------"
  echo "driver = pgsql"
  echo "connect=  dbname=clement"
  echo "#------------------------------------------"
  )  >> %{_sysconfdir}/%{name}-%{rvers}/dovecot-sql.conf
  fi
%endif

%if %with_mysql
%package mysql
Summary: Clement package working with MySQL data-base
Group: System Environment/Daemons
Version: %{rvers}.%{rrelease}
Release: %{rextension}%{?dist}
License: GPLv2
Requires(pre): %{name} = %{version}-%{release}
Requires: mysql-server
Requires: dovecot-mysql,php-mysql
Requires: /bin/sed
Requires: mysql
BuildRequires: mysql-devel

%description mysql
The clement application set to work with a MySQL data-base

%files mysql

%post mysql
if [ "$1" = 1 ]; then
  (
  echo "#------------------------------------------"
  echo "#DATA BASE TYPE as set by %{name}-mysql RPM"
  echo "DB_TYPE=MYSQL"
  echo "#------------------------------------------"
  ) >> %{_sysconfdir}/sysconfig/%{name}
  (
  echo "#------------------------------------------"
  echo "driver = mysql"
  echo "connect= host=localhost dbname=clement"
  echo "#------------------------------------------"
  )  >> %{_sysconfdir}/%{name}-%{rvers}/dovecot-sql.conf
  fi
%endif

#-----------------------------------------------------------
#-----------------------------------------------------------
#common part
#-----------------------------------------------------------
%prep

%setup -q

%build
%{__rm} -rf %{buildroot}
%{?_smp_mflags:%define _smp_mflags -j `/usr/bin/getconf _NPROCESSORS_ONLN`}
%if %with_postgresql
export with_postgresql=%{with_postgresql}
%endif
%if %with_mysql
export with_mysql=%{with_mysql}
%endif
%{!?with_debug:%define with_debug 0}
%if %with_debug
export with_debug=%{with_debug}
%endif

%define DIST %(echo %{?dist}| cut -d'.' -f2-)
%if "%{?dist}" == ".rh7.3" 
%define DIST rh73
%endif

%if "%{?dist}" == ".rh8.0" 
%define DIST rh80
%endif

#generating uptodate version information
(
echo "export VERSION=%{rversion}";		\
echo "export LEVEL=%{rlevel}";			\
echo "export RELEASE=%{rrelease}";		\
echo "export UPDATE=%{rupdate}";		\
echo "export EXT=%{rextension}";		\
echo "export VMARK=	";			\
echo "export VERS=\$(VERSION).\$(LEVEL)";	\
) > Makefile.vers

(
echo -e "#define\tVERSION\t%{rversion}";	\
echo -e "#define\tLEVEL\t%{rlevel}";		\
echo -e "#define\tRELEASE\t%{rrelease}";	\
echo -e "#define\tUPDATE\t%{rupdate}";		\
echo -e "#define\tEXT\t%{rextension}";		\
echo -e "#define\tVMARK\t	";		\
) > lib/vers.h

sed 						\
  -e "s/=VERSION/=%{rversion}/"			\
  -e "s/=LEVEL/=%{rlevel}/"			\
  -e "s/=RELEASE/=%{rrelease}/"			\
  -e "s/=UPDATE/=%{rupdate}/"			\
	shell/version.tpl > shell/version.sh ;	\
	
%{__make} -s %{?_smp_mflags} DIST=%{?DIST} prod

%clean 
%{__rm} -rf %{buildroot}

%install
#main install
%{__rm} -fr %{buildroot}
mkdir -p -m0755 %{buildroot}

%{__make} -s install DESTDIR=%{buildroot}

%if %{with_repo}
install -dm 755 %{buildroot}/%{_sysconfdir}/yum.repos.d
%define DIST %(echo %{?dist}| cut -d'.' -f2-)
export DOREPO=yes
case "%{?DIST}" in
  "sl6.1"	|					\
  "sl6.0"		)
    export REPODIST=scientific 
    ;;
  "el6.3"	|					\
  "el6.2"	|					\
  "el6.1"	|					\
  "el6.0"	|					\
  "el5.8"	|					\
  "el5.7"	|					\
  "el5.6"	|					\
  "el5.5"	|					\
  "el5.4"	|					\
  "el5.3"	|					\
  "el5.2"	|					\
  "el4.9"	|					\
  "el4.8"	|					\
  "el4.7"	|					\
  "el4.6"	)
    export REPODIST=centos 
    ;;
  "fc6"		|					\
  "fc5"		|					\
  "fc4"		|					\
  "fc3"		|					\
  "fc2"		)
    export REPODIST=fedora-core 
    ;;
  "fc15"	|					\
  "fc14"	|					\
  "fc13"	|					\
  "fc12"	|					\
  "fc11"	|					\
  "fc10"	|					\
  "fc9"		|					\
  "fc8"		|					\
  "fc7"		)
    export REPODIST=fedora-release 
    ;;
  *		)
    export DOREPO=no
    ;;
  esac
if [ "$DOREPO" == "yes" ] ; then
  cat > %{buildroot}/%{_sysconfdir}/yum.repos.d/%{name}.repo << !EOT
#------------------------------------------------------------------------------------
[Clement]
name=SAFE Clement "An SMTP firewall" - Released Updates
mirrorlist=http://mirrors.safe.ca/?&prj=public&dist=$REPODIST&rls=\$releasever&arch=\$basearch&subdir=safe
enabled=1
gpgcheck=0
#------------------------------------------------------------------------------------
#if your distribution do not provide a good enough clamav, dovecot, rrdtool 
#squirrelmail RPM, you can enable this extras repository
#and get missing from SAFE site.
[SAFE-public-extras]
name=Extras package - Release needed by clement
mirrorlist=http://mirrors.safe.ca/?&prj=public&dist=$REPODIST&rls=\$releasever&arch=\$basearch&subdir=extras
enabled=0
gpgcheck=0
#------------------------------------------------------------------------------------
#this distribution is provided to get clement very beta Version
#DO NOT ENABLE IT, unless you know perfectly what want to do.
[safe-test]
name=SAFE application - RAW Test channel
mirrorlist=http://mirrors.safe.ca/?&prj=public&dist=$REPODIST&rls=\$releasever&arch=\$basearch&subdir=safe-test
enabled=0
gpgcheck=0
#------------------------------------------------------------------------------------

!EOT
  fi
%endif

%changelog
* Mon Oct 10 2011 Jean-Marc Pigeon <jmp@safe.ca> 2.5.142-3
  - Improvements
    * Warning email to originator, if email is still pending after 3 strikes
    * Trouble report is now bilingual and handle by a shell script (trouble.sh)
      Email delivery trouble is now more detailed.

  - Bug fix
    * Sending multiple rebounce if multiple error generated with the same email to relay.
